class CookbookClient::Cuisine
  attr_accessor :id, :name

  def initialize(info:)
    @id = info['id']
    @name = info['name']
  end

  def self.all
    response = CookbookClient.http.get('/api/v1/cuisines')

    if response.status != 200
      raise StandardError, "Error #{response.status} - #{response.body}"
    end

    format_cuisines cuisines: JSON.parse(response.body)
  end

  def self.find_by_name(name)
    response = CookbookClient.http.get('/api/v1/cuisines/name', name: name)

    if response.status != 200
      raise StandardError, "Error #{response.status} - #{response.body}"
    end

    format_cuisines(cuisines: JSON.parse(response.body)).first
  end

  def self.format_cuisines(cuisines:)
    cuisines = [cuisines] unless cuisines.is_a? Array
    cuisines.map do |c|
      new info: c
    end
  end
end
