class CookbookClient::RecipeType
  attr_accessor :id, :name

  def initialize(info:)
    @id = info['id']
    @name = info['name']
  end

  def self.all
    response = CookbookClient.http.get('/api/v1/recipe_types')

    if response.status != 200
      raise StandardError, "Error #{response.status} - #{response.body}"
    end

    format_recipe_type recipe_types: JSON.parse(response.body)
  end

  def self.find_by_name(name)
    response = CookbookClient.http.get('/api/v1/recipe_types/name', name: name)

    if response.status != 200
      raise StandardError, "Error #{response.status} - #{response.body}"
    end

    format_recipe_type(recipe_types: JSON.parse(response.body)).first
  end

  def self.format_recipe_type(recipe_types:)
    recipe_types = [recipe_types] unless recipe_types.is_a? Array
    recipe_types.map do |rp|
      new info: rp
    end
  end
end
